var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
// import invariant from 'invariant';
import * as PropTypes from 'prop-types';
import * as React from 'react';
import { Component } from 'react';
import { FormProvider } from './FormContext';
import { withValidators } from './ValidatorsContext';
var removeFrom = function (original) { return function (fieldsToRemove) {
    return Object.entries(original)
        .filter(function (_a) {
        var fieldName = _a[0];
        return !fieldsToRemove.includes(fieldName);
    })
        .reduce(function (all, _a) {
        var fieldName = _a[0], fieldValue = _a[1];
        var _b;
        return (__assign({}, all, (_b = {}, _b[fieldName] = fieldValue, _b)));
    }, {});
}; };
var Form = /** @class */ (function (_super) {
    __extends(Form, _super);
    function Form() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            config: {},
            errors: {},
            fields: {},
            submitted: false,
        };
        _this.onChange = function (e) {
            var _a;
            if (!_this.state.config[e.target.name]) {
                return;
            }
            var value = e.target.type === 'checkbox' ? e.target.checked : e.target.value;
            var fields = __assign({}, _this.state.fields, (_a = {}, _a[e.target.name] = value, _a));
            var errors = _this.validate(fields, _this.state.config);
            _this.setState({ errors: errors, fields: fields });
        };
        _this.onReset = function (e) {
            e && e.preventDefault();
            var onReset = _this.props.onReset;
            _this.setState(function (prevState) { return ({
                submitted: false,
                errors: Object.keys(prevState.errors).reduce(function (acc, field) {
                    var _a;
                    return (__assign({}, acc, (_a = {}, _a[field] = null, _a)));
                }, {}),
                fields: Object.keys(prevState.fields).reduce(function (acc, field) {
                    var _a;
                    return (__assign({}, acc, (_a = {}, _a[field] = '', _a)));
                }, {}),
            }); });
            onReset && onReset();
        };
        _this.onSubmit = function (e) {
            e && e.preventDefault();
            var onSubmit = _this.props.onSubmit;
            _this.setState({ submitted: true });
            var _a = _this.state, errors = _a.errors, fields = _a.fields;
            onSubmit && onSubmit({
                errors: errors,
                fields: fields,
                isValid: Object.values(errors).every(function (error) { return error === null; }),
            });
        };
        _this.setField = function (diff) {
            var fields = __assign({}, _this.state.fields, diff);
            var errors = _this.validate(fields, _this.state.config);
            _this.setState({ errors: errors, fields: fields });
        };
        _this.validate = function (fields, config) {
            return Object.entries(config).reduce(function (allErrors, _a) {
                var name = _a[0], fieldConfig = _a[1];
                var _b;
                return (__assign({}, allErrors, (_b = {}, _b[name] = _this.validateField(fieldConfig, name, fields, allErrors), _b)));
            }, {});
        };
        _this.validateField = function (fieldValidators, name, allFields, allErrors) {
            return Object.entries(fieldValidators).reduce(function (error, _a) {
                var validatorName = _a[0], validatorConfig = _a[1];
                if (error)
                    return error;
                var validator = _this.props.validators[validatorName];
                /*invariant(
                    validator,
                    "You specified a validator that doesn't exist. You " +
                    `specified ${validatorName}. Available validators: \n\n` +
                    Object.keys(this.props.validators).join(',\n'),
                );*/
                var context = {
                    fields: allFields,
                    errors: __assign({}, _this.state.errors, allErrors),
                };
                if (typeof validatorConfig === 'function') {
                    validatorConfig = validatorConfig(context);
                }
                if (typeof validatorConfig === 'string') {
                    validatorConfig = { message: validatorConfig };
                }
                if (typeof validatorConfig.validateIf === 'function' &&
                    !validatorConfig.validateIf(context)) {
                    return null;
                }
                else if (typeof validatorConfig.validateIf === 'boolean' &&
                    !validatorConfig.validateIf) {
                    return null;
                }
                return validator(validatorConfig)(allFields[name]);
            }, null);
        };
        _this.registerSubComponent = function (subComponentConfig, initialValues) {
            var config = __assign({}, _this.state.config, subComponentConfig);
            var fields = __assign({}, _this.state.fields, initialValues);
            var errors = _this.validate(fields, config);
            _this.setState(function (prevState) { return ({
                config: __assign({}, prevState.config, config),
                fields: __assign({}, prevState.fields, fields),
                errors: __assign({}, prevState.errors, errors),
            }); });
        };
        _this.unregisterSubComponent = function (fieldsToRemove) {
            var keys = Object.keys(fieldsToRemove);
            var fields = removeFrom(_this.state.fields)(keys);
            var config = removeFrom(_this.state.config)(keys);
            var errors = removeFrom(_this.state.errors)(keys);
            _this.setState({
                config: config,
                errors: _this.validate(fields, config),
                fields: fields,
            });
        };
        return _this;
    }
    Form.prototype.render = function () {
        var _a = this.props, children = _a.children, onSubmit = _a.onSubmit, rest = __rest(_a, ["children", "onSubmit"]);
        var formContext = {
            errors: this.state.errors,
            fields: this.state.fields,
            register: this.registerSubComponent,
            resetAll: this.onReset,
            setField: this.setField,
            submit: this.onSubmit,
            submitted: this.state.submitted,
            unregister: this.unregisterSubComponent,
        };
        return (React.createElement("form", __assign({ onChange: this.onChange, onSubmit: this.onSubmit, onReset: this.onReset }, rest),
            React.createElement(FormProvider, { value: formContext }, children)));
    };
    Form.defaultProps = {
        onSubmit: function (f) { return f; },
        onReset: function (f) { return f; },
    };
    Form.propTypes = {
        onSubmit: PropTypes.func,
        onReset: PropTypes.func,
        validators: PropTypes.shape({}).isRequired,
    };
    return Form;
}(Component));
export default withValidators(Form);
//# sourceMappingURL=../../src/dist/form/Form.js.map