import * as React from 'react';
interface FormConfig {
    [key: string]: any;
}
interface FormErrors {
    [key: string]: string | null;
}
interface FormFields {
    [key: string]: string | null;
}
interface FormModel {
    errors: FormErrors;
    fields: FormFields;
    register: (config: FormConfig, initialValues: FormFields) => void;
    resetAll: () => void;
    setField: () => void;
    submit: () => void;
    submitted: boolean;
    unregister: (FormFieldModel: any) => void;
}
declare const FormConsumer: React.ExoticComponent<React.ConsumerProps<{}>>;
declare const FormProvider: React.ProviderExoticComponent<React.ProviderProps<{}>>;
declare const withFormContext: <P extends Partial<FormModel>>(TargetComponent: React.ComponentClass<P, any> | React.FunctionComponent<P>) => {
    (props: P): JSX.Element;
    displayName: string;
};
export { FormConfig, FormConsumer, FormErrors, FormFields, FormModel, FormProvider, withFormContext };
