var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as PropTypes from 'prop-types';
import * as React from 'react';
import { withFormContext } from './FormContext';
var Validation = /** @class */ (function (_super) {
    __extends(Validation, _super);
    function Validation() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getFields = function (source) {
            var config = _this.props.config;
            var getFirstDefinedValue = function () {
                var values = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    values[_i] = arguments[_i];
                }
                return values.find(function (value) { return value !== undefined; });
            };
            return Object.keys(config).reduce(function (allFields, field) {
                var _a;
                return (__assign({}, allFields, (_a = {}, _a[field] = getFirstDefinedValue(source[field], ''), _a)));
            }, {});
        };
        return _this;
    }
    Validation.prototype.componentDidMount = function () {
        var _a = this.props, register = _a.register, initialValues = _a.initialValues, config = _a.config;
        register && register(config, this.getFields(initialValues));
    };
    Validation.prototype.componentWillUnmount = function () {
        var _a = this.props, config = _a.config, unregister = _a.unregister;
        unregister && unregister(config);
    };
    Validation.prototype.render = function () {
        var _a = this.props, errors = _a.errors, fields = _a.fields, resetAll = _a.resetAll, submit = _a.submit, submitted = _a.submitted, children = _a.children, setField = _a.setField;
        var childrenArgs = {
            errors: errors,
            fields: this.getFields(fields),
            resetAll: resetAll,
            setField: setField,
            submit: submit,
            submitted: submitted
        };
        return children(childrenArgs);
    };
    Validation.defaultProps = {
        errors: {},
        fields: {},
        initialValues: {},
    };
    Validation.propTypes = {
        config: PropTypes.shape({}).isRequired,
        errors: PropTypes.shape({}),
        fields: PropTypes.shape({}),
        register: PropTypes.func,
        resetAll: PropTypes.func,
        submitted: PropTypes.bool,
        submit: PropTypes.func,
        unregister: PropTypes.func,
    };
    return Validation;
}(React.Component));
export default withFormContext(Validation);
//# sourceMappingURL=../../src/dist/form/Validation.js.map