var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component, createContext } from 'react';
import { shape } from 'prop-types';
import { isBlacklisted, isEmail, isEqual, isGreaterThan, isLessThan, isRequired, isNumber, isRegexMatch, isWhitelisted, isMinLength, isMaxLength, isExactLength, } from '310-logic/valid';
var defaultValidators = {
    isBlacklisted: isBlacklisted,
    isEmail: isEmail,
    isEqual: isEqual,
    isGreaterThan: isGreaterThan,
    isLessThan: isLessThan,
    isRequired: isRequired,
    isNumber: isNumber,
    isRegexMatch: isRegexMatch,
    isWhitelisted: isWhitelisted,
    isMinLength: isMinLength,
    isMaxLength: isMaxLength,
    isExactLength: isExactLength,
};
var _a = createContext({}), Provider = _a.Provider, Consumer = _a.Consumer;
var ValidatorsProvider = /** @class */ (function (_super) {
    __extends(ValidatorsProvider, _super);
    function ValidatorsProvider() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = __assign({}, _this.props.validators);
        return _this;
    }
    ValidatorsProvider.getDerivedStateFromProps = function (nextProps) {
        return nextProps.validators || null;
    };
    ValidatorsProvider.prototype.render = function () {
        return React.createElement(Provider, { value: this.state }, this.props.children);
    };
    ValidatorsProvider.defaultProps = {
        validators: {},
    };
    ValidatorsProvider.propTypes = {
        validators: shape({}),
    };
    return ValidatorsProvider;
}(Component));
export { ValidatorsProvider };
export var ValidatorsConsumer = Consumer;
export var withValidators = function (TargetComponent) {
    var WithValidators = function (props) { return (React.createElement(Consumer, null, function (validators) { return (React.createElement(TargetComponent, __assign({}, props, { validators: __assign({}, defaultValidators, validators) }))); })); };
    var targetName = TargetComponent.displayName || TargetComponent.name;
    WithValidators.displayName = "withValidators(" + targetName + ")";
    return WithValidators;
};
//# sourceMappingURL=../../src/dist/form/ValidatorsContext.js.map