var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import { GROUP } from '310-logic/component/Group';
var renderItems = function (items) {
    return items && items.map(function (item) {
        switch (item.type) {
            case GROUP: {
                var active = item.active, icon = item.icon, items_1 = item.items, text = item.text, type = item.type, props = __rest(item, ["active", "icon", "items", "text", "type"]);
                return (React.createElement("li", __assign({}, props),
                    active && '[',
                    text,
                    active && ']',
                    " (",
                    props.key,
                    ")",
                    items_1 && items_1.length ? null : '>',
                    React.createElement("ul", null, renderItems(items_1))));
            }
            default: {
                var active = item.active, icon = item.icon, text = item.text, type = item.type, props = __rest(item, ["active", "icon", "text", "type"]);
                return (React.createElement("li", __assign({}, props),
                    active && '[',
                    text,
                    active && ']',
                    " (",
                    props.key,
                    ")"));
            }
        }
    });
};
var renderReturn = function (head) {
    if (!head) {
        return;
    }
    var active = head.active, icon = head.icon, key = head.key, text = head.text, props = __rest(head, ["active", "icon", "key", "text"]);
    return (React.createElement("h3", __assign({}, props),
        "< ",
        text,
        " (",
        key,
        ")"));
};
var renderGrouppedItems = function (items) { return (React.createElement(React.Fragment, null, items && items.map(function (item) {
    switch (item.type) {
        case GROUP: {
            var active = item.active, icon = item.icon, items_2 = item.items, text = item.text, type = item.type, props = __rest(item, ["active", "icon", "items", "text", "type"]);
            return (React.createElement(React.Fragment, { key: props.key + '-f' },
                React.createElement("h4", __assign({}, props),
                    active && '[',
                    text,
                    active && ']',
                    " (",
                    props.key,
                    ")"),
                renderItems(items_2),
                React.createElement("div", { key: props.key + '-d', style: { borderBottom: '#000 solid 1px', width: '100%' } })));
        }
        default: {
            var active = item.active, icon = item.icon, text = item.text, type = item.type, props = __rest(item, ["active", "icon", "text", "type"]);
            return (React.createElement("li", __assign({}, props),
                active && '[',
                text,
                active && ']',
                " (",
                props.key,
                ")"));
        }
    }
}))); };
var List = function (_a) {
    var head = _a.head, items = _a.items, variant = _a.variant, props = __rest(_a, ["head", "items", "variant"]);
    var _b = React.useState([]), active = _b[0], setActive = _b[1];
    return (React.createElement(React.Fragment, null,
        renderReturn(head),
        React.createElement("ul", null, variant === 'group' ? renderGrouppedItems(items) : renderItems(items))));
};
export default List;
//# sourceMappingURL=../../src/dist/list/List.js.map