var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import { GROUP } from '310-logic/component/Group';
import { useState } from 'react';
import has from '310-logic/component/has';
import pathTest from './pathTest';
var SEPARATOR = '-';
var useList = function (config) {
    var isDisabled = pathTest(config.disabled);
    var isHighlighted = pathTest(config.highlighted);
    var handler = useState(new WeakMap())[0];
    function initStack(selection) {
        var group = config.variant && has(config.variant, 'group');
        var menu = config.view === 'menu';
        var tree = config.view === 'tree';
        var flat = !(menu || tree);
        var stack = [];
        var root = Math.max(0, group ? selection.length - 2 : selection.length - 1);
        var handlerSet = function (key /*, methods: { [key: string]: (key: string) => (e: MouseEvent) => void; }*/) {
            var handlerKey;
            var handlerSet;
            if (handler.has(handlerKey = { key: key })) {
                handlerSet = handler.get(handlerKey);
            }
            else {
                handler.set(handlerKey, handlerSet = {
                    onClick: handleClick(key, selection),
                    onMouseDown: config.preview ? handleMouseDown(key, selection) : undefined
                });
            }
            return handlerSet;
        };
        var visit = function (items, path, index, select) {
            return items.map(function (item, i) {
                var curr = path.length ? path.concat([i]) : [i];
                var key = curr.join(SEPARATOR);
                var active = (select && index < config.active.length && i === config.active[index]) || undefined;
                var disabled = isDisabled(curr) || undefined;
                var highlighted = isHighlighted(curr) || undefined;
                switch (item.type) {
                    case GROUP: {
                        var items_1 = menu || active || (group && index < (tree ? 1 : root + 1))
                            ? visit(item.items, curr, index + 1, active === true)
                            : [];
                        var itms = item.items, g = __rest(item, ["items"]);
                        var props = __assign({}, g, handlerSet(key), { active: active,
                            disabled: disabled,
                            highlighted: highlighted,
                            items: items_1,
                            key: key });
                        if (active) {
                            stack.push(props);
                        }
                        return props;
                    }
                    default:
                        return __assign({}, item, handlerSet(key), { active: active,
                            disabled: disabled,
                            highlighted: highlighted,
                            key: key });
                }
            });
        };
        var queue = [visit(config.items, [], 0, true)].concat(stack.map(function (group) { return group.items; }).reverse());
        var head = undefined;
        if (flat && stack.length) {
            if (config.active.length === 0 && (group && config.active.length < 2)) {
                root = 0;
            }
            else {
                root = group ? stack.length - 1 : stack.length;
                head = stack.reverse()[root - 1];
            }
        }
        else {
            root = 0;
        }
        return [
            queue,
            head,
            root
        ];
    }
    ;
    function handleClick(key, selection) {
        return function (event) {
            event.preventDefault();
            event.stopPropagation();
            var group = config.variant && has(config.variant, 'group');
            var menu = config.view === 'menu';
            var tree = config.view === 'tree';
            var flat = !(menu || tree);
            var active = key.split(SEPARATOR).map(function (s) { return Number(s); });
            console.log('click', key, 'selection: ', selection);
            if (flat && selection.join(SEPARATOR).startsWith(key)) {
                active = active.slice(0, -1);
                console.log('go back', active);
            }
            config.setActive(active, false, event);
        };
    }
    /**
     * in useNav it is used to open in another tab if event.button === 1
     **/
    function handleMouseDown(key, selection) {
        return function (event) {
            var active = key.split(SEPARATOR).map(function (s) { return Number(s); });
            config.setActive(active, true, event);
        };
    }
    var _a = initStack(config.active), stack = _a[0], head = _a[1], root = _a[2];
    return {
        head: head,
        items: stack[root]
    };
};
export default useList;
//# sourceMappingURL=../../src/dist/list/useList.js.map